diff --git a/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
index ec5e577ff..ba637d1ba 100644
--- a/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
+++ b/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -55,7 +55,7 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
 
     @Override
     public @NotNull Vec3 getCoordinates(boolean offsetHeight) {
-        Vec3 position = this.getSender().getPosition(1.0f);
+        Vec3 position = this.getSender().getPosition(1.0f, false);
         if (offsetHeight) return position.add(0.0f, -this.getSender().heightOffset, 0.0f);
         return position;
     }
diff --git a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
index 35e1c234a..458320918 100644
--- a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
@@ -169,7 +169,7 @@ public class ServerPacketHandler extends PacketHandler
                 worldserver.updateEntity(playerEntity);
                 return;
             }
-            double d1 = playerEntity.y;
+            double oldY = playerEntity.y;
             lastPosX = playerEntity.x;
             lastPosY = playerEntity.y;
             lastPosZ = playerEntity.z;
@@ -275,7 +275,7 @@ public class ServerPacketHandler extends PacketHandler
             }
             playerEntity.onGround = packet.onGround;
             mcServer.playerList.func_613_b(playerEntity);
-            playerEntity.handleFalling(playerEntity.y - d1, packet.onGround);
+            playerEntity.handleFalling(playerEntity.y - oldY, packet.onGround);
 
         }
     }
@@ -330,14 +330,13 @@ public class ServerPacketHandler extends PacketHandler
         }
 
         // Check spawn protection
-        boolean ignoreSpawnProtection = world.field_819_z = mcServer.spawnProtectionRange <= 0 || world.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.uuid);
+        boolean ignoreSpawnProtection = mcServer.spawnProtectionRange <= 0 || world.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.uuid);
         ChunkCoordinates spawnPos = world.getSpawnPoint();
         int spawnDistX = (int) MathHelper.abs(x - spawnPos.x);
         int spawnDistZ = (int) MathHelper.abs(z - spawnPos.z);
         int distanceFromSpawn = Math.max(spawnDistX, spawnDistZ);
         if(distanceFromSpawn <= mcServer.spawnProtectionRange && !ignoreSpawnProtection) {
             playerEntity.playerNetServerHandler.sendPacket(new BlockUpdatePacket(x, y, z, world));
-            world.field_819_z = false;
             return;
         }
 
@@ -354,7 +353,6 @@ public class ServerPacketHandler extends PacketHandler
                 playerEntity.playerNetServerHandler.sendPacket(new BlockUpdatePacket(x, y, z, world));
             }
         }
-        world.field_819_z = false;
     }
 
     public void handleSendInitialPlayerList()
@@ -371,7 +369,7 @@ public class ServerPacketHandler extends PacketHandler
         if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
         ItemStack itemstack = playerEntity.inventory.getCurrentItem();
-        boolean flag = worldserver.field_819_z = worldserver.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.uuid);
+        boolean ignoreSpawnProtection = mcServer.spawnProtectionRange <= 0 || worldserver.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.uuid);
         if (packet.direction == Direction.NONE)
         {
             if (itemstack == null)
@@ -395,7 +393,7 @@ public class ServerPacketHandler extends PacketHandler
             {
                 j1 = i1;
             }
-            if (hasMoved && playerEntity.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) < 64D && (j1 > mcServer.spawnProtectionRange || flag))
+            if (hasMoved && playerEntity.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) < 64D && (j1 > mcServer.spawnProtectionRange || ignoreSpawnProtection))
             {
                 playerEntity.playerController.activateBlockOrUseItem(playerEntity, worldserver, itemstack, x, y, z, direction.getSide(), xPlaced, yPlaced);
             }
@@ -415,11 +413,14 @@ public class ServerPacketHandler extends PacketHandler
         Slot slot = playerEntity.craftingInventory.getSlotFor(playerEntity.inventory, playerEntity.inventory.getCurrentItemIndex());
         playerEntity.craftingInventory.broadcastChanges();
         playerEntity.isChangingQuantityOnly = false;
+        if (slot == null) {
+            LOGGER.warn("Couldn't find slot for index '{}' in {}'s inventory while they were in the {} container!", playerEntity.inventory.getCurrentItemIndex(), playerEntity.username, playerEntity.craftingInventory.getClass().getSimpleName());
+            return;
+        }
         if (!ItemStack.areItemStacksEqual(playerEntity.inventory.getCurrentItem(), packet.itemStack))
         {
             sendPacket(new ContainerSetSlotPacket(playerEntity.craftingInventory.containerId, slot.index, playerEntity.inventory.getCurrentItem()));
         }
-        worldserver.field_819_z = false;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index b94708763..9a92019e7 100644
--- a/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -121,7 +121,7 @@ public class ServerPlayerController
     	}
         Block block = Block.getBlock(id);
         BlockEntity blockEntity = thisWorld.getBlockEntity(x, y, z);
-        thisWorld.playSoundEffect(player, 2001, x, y, z, id);
+        thisWorld.playBlockEvent(player, 2001, x, y, z, id);
         boolean flag = removeBlock(x, y, z);
         if(flag) {
         	if(block != null) {
diff --git a/src/main/java/net/minecraft/server/world/WorldServer.java b/src/main/java/net/minecraft/server/world/WorldServer.java
index bfdbf2b9b..05158ca3d 100644
--- a/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -33,7 +33,6 @@ public class WorldServer extends World
     public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed, SpawnerMobs.SpawnerConfig spawnerConfig)
     {
         super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType, spawnerConfig);
-        field_819_z = false;
         entityIntHashMap = new IntHashMap<>();
         mcServer = minecraftserver;
     }
@@ -262,7 +261,6 @@ public class WorldServer extends World
         super.addRainbow(rainbowTicks);
     }
     public ChunkProviderServer chunkProviderServer;
-    public boolean field_819_z;
     public boolean dontSave;
     public MinecraftServer mcServer;
     private final IntHashMap<Entity> entityIntHashMap;
